; Fformat (device$)
; format a sectored medium
; & return the number of good sectors

        MOVE.W  $110,A2
        LEA.L   procdef,A1
        JMP     (A2)
        
procdef 
        DC.W    0,0
        DC.W    1
        DC.W    Ffstart-*
        DC.B    7,'Fformat',0
        DC.W    0
        
Ffstart
        MOVE.W  $116,A0
        JSR     (A0)
        TST.L   D0
        BNE.S   err_exit
        MOVEQ   #-15,D0
        CMPI.W  #1,D3
        BNE.S   err_exit
        
        ; now 0(A6,A1.L)  = Pointer to string
        MOVEQ   #3,D0                   ; IO.FORMT
        MOVE.L  A1,A0                   ; Pointer to medium name
        TRAP    #4                      ; BP.ABSIO
        TRAP    #2                      ; Do the format 
        MOVE.W  D1,D7                   ; D7 = The result
        TST.L   D0
        BEQ.S   ok
        MOVE.W  D0,D7
        BSR.S   clr_rel_A6
        
ok      ; so stack D0
        MOVE.L  $58(A6),A1
        SUBQ    #2,A1
        MOVE.W  D7,0(A6,A1.L)           ; Store result on RI
        MOVE.L  A1,$58(A6)              ; Store new RI SP
        CLR.L   D0                      ; No error
        MOVEQ   #3,D4                   ; Ret integer
err_exit
        RTS
        
clr_rel_A6
        MOVE.L  $28064,A3               ; Current job  
        MOVE.L  (A3),A3                 ; Find header start
        BCLR    #7,$16(A3)              ; Clear the bit      
        RTS
