; STAT (device$)
; Open_in a channel to a device$
; store error
; close channel
; return error

BP_INIT  EQU     $110
CA_GTSTR EQU     $116
        MOVE.W  BP_INIT,A2
        LEA.L   procdef,A1
        JMP     (A2)

procdef DC.W    0,0
        DC.W    1
        DC.W    start-*
        DC.B    4,'STAT'
        DC.W    0

start   MOVE.W  CA_GTSTR,A0
        JSR     (A0)
        BNE.S   err_exit
        TST.L   D0                      ; Check for errors
        BNE.S   err_exit
        MOVEQ   #-15,D0
        CMP.W   #1,D3
        BNE.S   err_exit
; Now 0(A6,A1.L) = pointer to the string
        MOVEQ   #1,D0                   ; IO.OPEN
        MOVEQ   #1,D3                   ; OPEN_IN
        MOVEQ   #0,D1                   ; Job ID for SB
        MOVE.L  A1,A0                   ; A0=base of $ (rel A6)
        TRAP    #4                      ; BP.ABSIO
        TRAP    #2                      ; Do IO.OPEN
        MOVE.L  D0,D7                   ; Save D0
        TST.L   D0
        BNE.S   clr_rel_A6
; otherwise close channel A0
        MOVEQ   #2,D0
        TRAP    #2
        BRA     stk_D7
clr_rel_A6
        MOVE.L  $28064,A3
        MOVE.L  (A3),A3
        BCLR    #7,$16(A3)
stk_D7
        MOVE.L  $58(A6),A1
        SUBQ    #2,A1
        MOVE.W  D7,0(A6,A1.L)           ; Store result on RI stack
        MOVE.L  A1,$58(A6)
        CLR.L   D0
        MOVEQ   #3,D4
err_exit 
        RTS
        
